/*
	JkMemoBoard.h

	Author		: Kang, Jul Ki
	E-mail		: jkkang65@hanmail.net
	Homepage	: http://jkkang.net/
	Last Update	: April 24th, 2010

	Compiler: Visual C++ 6.0 & gcc 2.7.2 or higher
	Tab Size: 8
	
	Copyleft (c) 2010, Kang, Jul Ki
*/

#ifndef _JkMemoBoard_h_
#define _JkMemoBoard_h_

#include "qDecoder.h"
#include "JkMemo.h"
#include "JkMemoMain.h"
#include <time.h>
#include <string.h>

/**
 * This class is used for Main Board.
 */
class JkMemoBoard
{
	JkMemoMain*	m_pJkMemoMain;
	DbArticle*	m_pDbArticle;

	D_INDEX*	dIndex;
	T_INDEX*	tIndex;

	INDEX_STACK	stack;
	int		sp;
	int		m_iTotalArticle;

public:
	JkMemoBoard	(JkMemoMain* pInfoMain);
	~JkMemoBoard	();

	int	GetTotalArticle	() {	return	m_iTotalArticle;	}

	void	ShowList	();

	int	MainIndex	();
	void	PrintIndex	(int iTotal);
	int	GetIndex	(int iNum);
	void	AdjustIndex	();
	void	DateIndex	();
	void	ThreadIndex	();

	int	FindThread	(int iNum, int iUpper);
	int	InsertIndex	(int iNum, int iDepth);
	int	PushIndex	(int iNum, int i);
	int	PopIndex	(int *iNum, int *i);

	int	GetArticleInfo	(int iNum, DbList* head);
	void	FreeArticleInfo (DbList* head);

	void	Run		();
};

#endif // _JkMemoBoard_h_
